/* this is a UDP sender */

#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#define BUFLEN 100
#define NSENDS 1000

int main(int argc, char *argv[])
{
  int sockfd, i, count = 0;
  struct sockaddr_in servaddr;
  char buf[BUFLEN];

  if (argc < 3) 
  {
    fprintf(stderr,"USAGE: %s ip_addr port.\n", argv[0]);
    exit(-1);
  }

  if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) /* UDP */
  {
    perror("Can't get socket");
    exit(1);
  }

  memset(&servaddr, 0, sizeof(struct sockaddr_in));
  servaddr.sin_family = AF_INET;
  servaddr.sin_port = htons(atoi(argv[2]));
  inet_pton(AF_INET, argv[1], &servaddr.sin_addr);
  
 
  for (i=0; i< NSENDS; i++) 
  {
    if(sendto(sockfd, buf, sizeof(buf), 0, (struct sockaddr *)&servaddr, sizeof(servaddr)) < 0)
      perror("sendto");
    else
    {
      count++;
      printf("Sent datagram # %d\n", i);
    }
    
  }

  printf("Sent a total of %d datagrams.\n\n", count);
  close(sockfd);
  
  return 0;
}






