/* this is a UDP receipient */

#include <sys/socket.h>
#include <sys/types.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <signal.h>
#include <stdlib.h>
#include <string.h>

#define BUFLEN 100000

int main(int argc, char *argv[])
{
  int sockfd, len, count = 0, n;
  struct sockaddr_in servaddr, cliaddr;
  char buf[BUFLEN];


  if (argc < 2) 
  {
    fprintf(stderr,"USAGE: %s port.\n", argv[0]);
    exit(-1);
  }

  if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) 
  {
    perror("Cannot get socket");
    exit(1);
  }

  memset(&servaddr, 0, sizeof(servaddr));
  servaddr.sin_addr.s_addr = INADDR_ANY;
  servaddr.sin_family = AF_INET;
  servaddr.sin_port = htons(atoi(argv[1]));

  if (bind(sockfd, (struct sockaddr *)&servaddr, sizeof(servaddr)) < 0) 
  {
    perror("bind");
    exit(1);
    } 


  for(;;)
  {
    len = sizeof(cliaddr);
    n = recvfrom(sockfd, buf, sizeof(buf), 0, (struct sockaddr *)&cliaddr, &len);
    switch (n)
    {
    case -1:
      perror("recvfrom");
      break;
    default:
      count++;
      printf("Received %d datagrams\n\n", count);
      break;
    }
  }
  
  return 0;
}

 




